
import datetime
import os
import pwd
from gettext import gettext as _

import gobject
import gtk
import gnomevfs
import gc

try:
    import gnomecups
except ImportError:
    gnomecups = None

#import gdmclient

from mayanna_globals import mayanna_is_panel_applet
from mayanna_base import Item, ItemSource, Topic, IOrientationAware, mayanna_get_topic_for_uri
from mayanna_file import FileItem
#from mayanna_logout import LogoutDialog
from mayanna_recent import RecentAggregate, recent_model
from mayanna_util import *
#from mayanna_applications import MenuTree, RecentSettingsLaunchers, LauncherItem

# FIXME: Move these to another file?
from mayanna_applications import *
from mayanna_computer import *
from mayanna_library import * 
from mayanna_trash import TrashItem
    
class FavoritesTopic(Topic):
    '''
    Lists a heterogeneous set of browsable system items, such as devices/drives,
    printers, and nearby computers (using Avahi).  Also lists control panel
    launchers in a flat list.
    '''
    def __init__(self,prefs = None):
        Topic.__init__(self,
                       name="Favorites",
                       uri="topic://Favorites",
                       icon="gnome-favorites",
                       prefs=prefs
                       )
        #from mayanna_running import ComputerRunningSource
        #self.set_running_source_factory(lambda: ComputerRunningSource())
        self.update_time_timeout_id = None
        self.current_time = 0
        #self.fav = FavoritesSource()
        #self.fav.connect("reload",self.do_reload)
        self.source_list = []
        self.do_reload(self)
        bookmarks.connect("reload",self.changed)
        self.changed()
    def changed(self,y=None):
        #self.source_list = self.fav.get_items_uncached()
        self.source_list=[]
	try:
		for uri, itemclass in bookmarks.get_bookmarks_and_class():
		        mod, cls = itemclass.rsplit(".", 1)
		        dynmod = __import__(mod, None, None, cls)
		        dyncls = getattr(dynmod, cls)
		        dynobj = dyncls(uri=uri)
		        self.source_list.append( dynobj)
		       # delmod, cls,dynmod,dyncls,dynobj
		gc.collect()
		self.source_list = [ (word.name.lower(), i, word) for i, word in enumerate(self.source_list) ]
		self.source_list.sort()
		self.source_list = [ word for _, _, word in  self.source_list ]

		gc.collect()
	except:
		print("error")
        self.emit("reload")
       
    
    def accept_drops(self):
        return False
    
    def get_hint_color(self):
        return gtk.gdk.color_parse("darkred")
