#!/usr/bin/env python
from mayanna_gui_helpers import *
from mayanna_extra_widgets import *
from mayanna_panel_widgets import MayannaWidget
from mayanna_engine.mayanna_util import bookmarks, icon_factory, icon_theme, launcher
import sys
import os
import gc
import gnomeapplet

import datetime
import math
try:
     import pygtk
     pygtk.require("2.0")
except:
      pass
try:
    import gtk
    import gtk.glade
except:
    sys.exit(1)
import gobject

class MayannaGUI:   
    
    '''   Initilization   '''
   
    def __init__(self):
        
        #self.main_btn =  gtk.Button("Start")
        self.create_gui()
        
    def create_gui(self):
        
        '''
        Main Window holding everything inside it
        '''
        
        self.topicWindow = CairoWindow()
        #self.topicWindow = EdgeWindow(gtk.gdk.GRAVITY_EAST)
        #self.topicWindow = gtk.Window()
        self.topicWindow.window.show_all()
        if (self.topicWindow.window):
            self.topicWindow.window.connect("destroy", gtk.main_quit)
       # self.topicWindow.window.show()
        #elf.topicWindow.connect("focus-out-event",self.lose_focus)


        self.eventbox1 = gtk.EventBox()
        #self.eventbox1.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("black"))
        self.eventbox2 = gtk.EventBox()
        #self.eventbox2.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("white"))
        
        self.mainTable = gtk.VBox()    
        self.tooltips = gtk.Tooltips()
        
        self.topicWindow.window.set_skip_pager_hint(True)
        self.topicWindow.window.set_skip_taskbar_hint(True)
        self.topicWindow.window.set_decorated(True)
        #self.topicWindow.window.set_resizable(True)
        #self.topicWindow.window.set_size_request(210,-1)
        self.topicWindow.window.stick()
        self.edge_gravity = gtk.gdk.GRAVITY_WEST
        
    
        ''' 
        HeaderTable
        
        '''
        
        self.headerTable = gtk.VBox()
        self.mainTable.pack_start(self.headerTable,False)
        self.toolbar = gtk.Toolbar()
        tooltips = gtk.Tooltips()
        btn = UserToolMenuButton(tooltips)
        btn.show_all()
        self.toolbar.insert(btn,-1)
        btn = NewDocumentMenuButton(tooltips)
        btn.show_all()
        #self.toolbar.insert(btn,-1)
        btn = ShutdownToolButton(tooltips)
        btn.show_all()
        self.toolbar.insert(btn,-1)
        self.topicWindow.window.content.add(self.eventbox1)
        #self.topicWindow.window.add(self.eventbox1)
        self.eventbox1.add(self.eventbox2)
        self.eventbox1.set_visible_window(True)
        #self.eventbox1.set_border_width(1)
        self.eventbox2.add(self.mainTable)
        self.eventbox2.set_visible_window(True)
        self.eventbox2.set_border_width(1)
        self.eventbox1.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("black"))
        #self.eventbox2.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("grey"))
        
        
        
        self.headerTable.add(self.toolbar)
        btn = FriendlyClock()
        btn.show()
        self.headerTable.pack_start(btn)
        #self.headerTable.pack_start(TrayManagerBox())
        self.topicWindow.window.show_all()
        
        
        self.mayannapanel = MayannaWidget()
        self.mayannapanel.show_all()
        #self.mayannabox = self.mayannapanel.get_widget()
        #self.mayannabox.show_all()
        self.mainTable.pack_start(self.mayannapanel,False,False)
        self.mayannapanel.set_parent_size(self.topicWindow.window)
        
        
        
        
        self.taskbox = TaskBarBox()
        self.taskbox.show()
        #self.windowListBox.pack_start(self.taskbox)
        self.mainTable.pack_start(self.taskbox,False,False)
        
        hbox = gtk.HBox()
        from gvtray import *